"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
var axios_1 = __importDefault(require("axios"));
var form_data_1 = __importDefault(require("form-data"));
var qs_1 = __importDefault(require("qs"));
var VERSION = '0.0.11';
var Client = /** @class */ (function () {
    function Client(config) {
        this.config = config;
    }
    Object.defineProperty(Client.prototype, "apiBaseUrl", {
        get: function () {
            return this.config.apiBaseUrl ? this.config.apiBaseUrl : 'https://api.omise.co';
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Client.prototype, "vaultBaseUrl", {
        get: function () {
            return this.config.vaultBaseUrl ? this.config.vaultBaseUrl : 'https://vault.omise.co';
        },
        enumerable: false,
        configurable: true
    });
    Client.prototype.getRequest = function (request) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var response, error_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, request];
                    case 1:
                        response = _d.sent();
                        return [2 /*return*/, response === null || response === void 0 ? void 0 : response.data];
                    case 2:
                        error_1 = _d.sent();
                        if (((_a = error_1 === null || error_1 === void 0 ? void 0 : error_1.data) === null || _a === void 0 ? void 0 : _a.object) === 'error') {
                            return [2 /*return*/, error_1.data];
                        }
                        if (((_c = (_b = error_1 === null || error_1 === void 0 ? void 0 : error_1.response) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.object) === 'error') {
                            return [2 /*return*/, error_1.response.data];
                        }
                        throw error_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.post = function (endpoint, data, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getRequest(axios_1.default.post(endpoint, data, __assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion }))))];
            });
        });
    };
    Client.prototype.get = function (endpoint, params, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getRequest(axios_1.default.get(endpoint, __assign(__assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion })), { params: params, paramsSerializer: function (_params) {
                            return qs_1.default.stringify(_params);
                        } })))];
            });
        });
    };
    Client.prototype.patch = function (endpoint, data, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getRequest(axios_1.default.patch(endpoint, data, __assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion }))))];
            });
        });
    };
    Client.prototype.put = function (endpoint, data, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getRequest(axios_1.default.put(endpoint, data, __assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion }))))];
            });
        });
    };
    Client.prototype.delete = function (endpoint, data, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.getRequest(axios_1.default.delete(endpoint, __assign(__assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion })), { data: data })))];
            });
        });
    };
    Client.prototype.fileUpload = function (endpoint, data, apiKey, omiseVersion) {
        return __awaiter(this, void 0, void 0, function () {
            var form, _i, _a, key, value;
            return __generator(this, function (_b) {
                form = new form_data_1.default();
                if (data) {
                    for (_i = 0, _a = Object.keys(data); _i < _a.length; _i++) {
                        key = _a[_i];
                        value = data[key];
                        form.append(key, value);
                    }
                }
                return [2 /*return*/, this.getRequest(axios_1.default.post(endpoint, form, __assign({}, this.buildConfigure({ apiKey: apiKey, omiseVersion: omiseVersion, headers: form.getHeaders() }))))];
            });
        });
    };
    Client.prototype.buildConfigure = function (options) {
        var _a;
        return {
            baseURL: this.baseURL,
            headers: __assign({ 'User-Agent': "omise-nodejs/" + VERSION, 'Omise-Version': (options === null || options === void 0 ? void 0 : options.omiseVersion) || ((_a = this.config) === null || _a === void 0 ? void 0 : _a.omiseVersion) || '2019-05-29' }, options === null || options === void 0 ? void 0 : options.headers),
            auth: {
                username: (options === null || options === void 0 ? void 0 : options.apiKey) || this.getKey(),
                password: '',
            },
            timeout: 60 * 1000, // 60 seconds
        };
    };
    return Client;
}());
exports.Client = Client;
