import { RefundListResponse } from './../models/Refund';
import { ChargeSearch } from './../models/common';
import { ChargeResponse, ChargeListResponse, PaginationParams, NewChargeRequest, UpdateChargeRequest, DisputeResponse, EventListResponse, ScheduleListResponse, SearchResponse, RefundResponse } from '../models';
import { Client, Config } from '../Client';
export declare class ChargeResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(data: NewChargeRequest): Promise<ChargeResponse>;
    retrieve(id: string): Promise<ChargeResponse>;
    list(params?: PaginationParams): Promise<ChargeListResponse>;
    listEvents(id: string, params?: PaginationParams): Promise<EventListResponse>;
    update(id: string, params: UpdateChargeRequest): Promise<ChargeResponse>;
    capture(id: string): Promise<ChargeResponse>;
    expire(id: string): Promise<ChargeResponse>;
    reverse(id: string): Promise<ChargeResponse>;
    dispute(id: string): Promise<DisputeResponse>;
    markAsFailed(id: string): Promise<ChargeResponse>;
    markAsPaid(id: string): Promise<ChargeResponse>;
    listChargeSchedules(params?: PaginationParams): Promise<ScheduleListResponse>;
    search(params: ChargeSearch): Promise<SearchResponse>;
    refund(id: string): Promise<RefundResponse>;
    retrieveRefund(chargeId: string, refundId: string): Promise<RefundResponse>;
    listRefunds(id: string, params?: PaginationParams): Promise<RefundListResponse>;
}
