import { SearchResponse } from './../models/Search';
import { CustomerSearch } from './../models/common';
import { CardResource } from './CardResource';
import { CustomerResponse, CustomerListResponse, PaginationParams, ScheduleListResponse, NewCustomerRequest, UpdateCustomerRequest } from '../models';
import { Client, Config } from '../Client';
export declare class CustomerResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(data?: NewCustomerRequest): Promise<CustomerResponse>;
    retrieve(id: string): Promise<CustomerResponse>;
    list(params?: PaginationParams): Promise<CustomerListResponse>;
    update(id: string, data: UpdateCustomerRequest): Promise<CustomerResponse>;
    destroy(id: string): Promise<CustomerResponse>;
    listSchedules(customerId: string, params?: PaginationParams): Promise<ScheduleListResponse>;
    cardsOf(customerId: string): CardResource;
    search(params: CustomerSearch): Promise<SearchResponse>;
}
