import { DisputeSearch } from './../models/common';
import { DisputeResponse, DisputeListResponse, PaginationParams, UpdateDisputeRequest, SearchResponse } from '../models';
import { DocumentResource } from './DocumentResource';
import { Client, Config } from '../Client';
export declare class DisputeResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(chargeId: string): Promise<DisputeResponse>;
    retrieve(id: string): Promise<DisputeResponse>;
    list(params?: PaginationParams): Promise<DisputeListResponse>;
    listClosed(params?: PaginationParams): Promise<DisputeListResponse>;
    listOpen(params?: PaginationParams): Promise<DisputeListResponse>;
    listPending(params?: PaginationParams): Promise<DisputeListResponse>;
    update(id: string, data?: UpdateDisputeRequest): Promise<DisputeResponse>;
    accept(id: string): Promise<DisputeResponse>;
    close(id: string): Promise<DisputeResponse>;
    documentsOf(disputeId: string): DocumentResource;
    search(params: DisputeSearch): Promise<SearchResponse>;
}
