import { FundAccountSearch } from './../models/common';
import { FundAccountResponse, PaginationParams, NewFundAccountRequest, SearchResponse, UpdateFundAccountRequest, FundAccountListResponse, FundSourceListResponse, NewFundSourceRequest, FundSourceResponse } from '../models';
import { Client, Config } from '../Client';
export declare class FundAccountResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    list(params?: PaginationParams): Promise<FundAccountListResponse>;
    retrieve(id: string): Promise<FundAccountResponse>;
    create(data: NewFundAccountRequest): Promise<FundAccountResponse>;
    update(id: string, data: UpdateFundAccountRequest): Promise<FundAccountResponse>;
    destroy(id: string): Promise<FundAccountResponse>;
    search(params: FundAccountSearch): Promise<SearchResponse>;
    listFundSources(id: string, params?: PaginationParams): Promise<FundSourceListResponse>;
    createFundSource(id: string, data: NewFundSourceRequest): Promise<FundSourceResponse>;
}
