import { UpdateFundSourceRequest, ConfirmFundSourceRequest, ResentConfirmationFundSourceRequest } from './../models/FundSource';
import { FundSourceResponse, PaginationParams, NewFundSourceRequest } from '../models';
import { Client, Config } from '../Client';
export declare class FundSourceResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    list(params?: PaginationParams): Promise<FundSourceResponse>;
    retrieve(id: string): Promise<FundSourceResponse>;
    create(fundAccountId: string, data: NewFundSourceRequest): Promise<FundSourceResponse>;
    update(id: string, data: UpdateFundSourceRequest): Promise<FundSourceResponse>;
    destroy(id: string): Promise<FundSourceResponse>;
    confirm(id: string, data: ConfirmFundSourceRequest): Promise<FundSourceResponse>;
    resentConfirmation(id: string, data: ResentConfirmationFundSourceRequest): Promise<FundSourceResponse>;
}
