import { SearchResponse } from './../models/Search';
import { ChargeListResponse } from './../models/Charge';
import { NewLinkRequest } from './../models/Link';
import { LinkResponse, PaginationParams, LinkListResponse, LinkSearch } from '../models';
import { Client, Config } from '../Client';
export declare class LinkResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    retrieve(id: string): Promise<LinkResponse>;
    list(params?: PaginationParams): Promise<LinkListResponse>;
    create(data: NewLinkRequest): Promise<LinkResponse>;
    destroy(id: string): Promise<LinkResponse>;
    listCharges(id: string, params?: PaginationParams): Promise<ChargeListResponse>;
    search(params: LinkSearch): Promise<SearchResponse>;
}
