import { RecipientSearch } from './../models/common';
import { RecipientResponse, RecipientListResponse, ScheduleListResponse, NewRecipientRequest, UpdateRecipientRequest, PaginationParams, SearchResponse } from '../models';
import { Client, Config } from '../Client';
export declare class RecipientResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(data?: NewRecipientRequest): Promise<RecipientResponse>;
    retrieve(id: string): Promise<RecipientResponse>;
    list(params?: PaginationParams): Promise<RecipientListResponse>;
    update(id: string, data: UpdateRecipientRequest): Promise<RecipientResponse>;
    destroy(id: string): Promise<RecipientResponse>;
    verify(id: string): Promise<RecipientResponse>;
    listSchedules(id: string, params?: PaginationParams): Promise<ScheduleListResponse>;
    search(params: RecipientSearch): Promise<SearchResponse>;
}
