import { NewScheduleRequest } from './../models/Schedule';
import { ChargeScheduleSearch, TransferScheduleSearch } from './../models/common';
import { OccurrenceListResponse } from './../models/Occurrence';
import { ScheduleResponse, ScheduleListResponse, PaginationParams, SearchResponse } from '../models';
import { Client, Config } from '../Client';
export declare class ScheduleResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(data: NewScheduleRequest): Promise<ScheduleResponse>;
    destroy(id: string): Promise<ScheduleResponse>;
    list(params?: PaginationParams): Promise<ScheduleListResponse>;
    retrieve(id: string): Promise<ScheduleResponse>;
    listForCustomer(customerId: string, params?: PaginationParams): Promise<ScheduleListResponse>;
    listForRecipient(recipientId: string, params?: PaginationParams): Promise<ScheduleListResponse>;
    listTransferSchedules(params?: PaginationParams): Promise<ScheduleListResponse>;
    listChargeSchedules(params?: PaginationParams): Promise<ScheduleListResponse>;
    listOccurrences(id: string, params?: PaginationParams): Promise<OccurrenceListResponse>;
    searchChargeSchedules(params: ChargeScheduleSearch): Promise<SearchResponse>;
    searchTransferSchedules(params: TransferScheduleSearch): Promise<SearchResponse>;
}
