import { TransferSearch } from './../models/common';
import { ScheduleListResponse } from './../models/Schedule';
import { UpdateTransferRequest } from './../models/Transfer';
import { TransferResponse, NewTransferRequest, PaginationParams, TransferListResponse, SearchResponse } from '../models';
import { Client, Config } from '../Client';
export declare class TransferResource extends Client {
    protected get baseURL(): string;
    constructor(config: Config);
    protected getKey(): string;
    create(data: NewTransferRequest): Promise<TransferResponse>;
    retrieve(id: string): Promise<TransferResponse>;
    list(params?: PaginationParams): Promise<TransferListResponse>;
    update(id: string, data: UpdateTransferRequest): Promise<TransferListResponse>;
    destroy(id: string): Promise<TransferListResponse>;
    markAsPaid(id: string): Promise<TransferListResponse>;
    markAsSent(id: string): Promise<TransferListResponse>;
    listTransferSchedules(params?: PaginationParams): Promise<ScheduleListResponse>;
    search(params: TransferSearch): Promise<SearchResponse>;
}
