"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OmiseClient = void 0;
var TransferResource_1 = require("./TransferResource");
var ReceiptResource_1 = require("./ReceiptResource");
var OccurrenceResource_1 = require("./OccurrenceResource");
var LinkResource_1 = require("./LinkResource");
var ForexResource_1 = require("./ForexResource");
var EventResource_1 = require("./EventResource");
var ScheduleResource_1 = require("./ScheduleResource");
var DisputeResource_1 = require("./DisputeResource");
var ChargeResource_1 = require("./ChargeResource");
var AccountResource_1 = require("./AccountResource");
var BalanceResource_1 = require("./BalanceResource");
var CapabilityResource_1 = require("./CapabilityResource");
var CustomerResource_1 = require("./CustomerResource");
var ChainResource_1 = require("./ChainResource");
var TokenResource_1 = require("./TokenResource");
var SourceResource_1 = require("./SourceResource");
var SearchResource_1 = require("./SearchResource");
var TransactionResource_1 = require("./TransactionResource");
var FundRequestResource_1 = require("./FundRequestResource");
var FundSourceResource_1 = require("./FundSourceResource");
var FundAccountResource_1 = require("./FundAccountResource");
var OmiseClient = /** @class */ (function () {
    function OmiseClient(config) {
        this.config = config;
        this.account = new AccountResource_1.AccountResource(config);
        this.balance = new BalanceResource_1.BalanceResource(config);
        this.capability = new CapabilityResource_1.CapabilityResource(config);
        this.customer = new CustomerResource_1.CustomerResource(config);
        this.chain = new ChainResource_1.ChainResource(config);
        this.charge = new ChargeResource_1.ChargeResource(config);
        this.dispute = new DisputeResource_1.DisputeResource(config);
        this.event = new EventResource_1.EventResource(config);
        this.forex = new ForexResource_1.ForexResource(config);
        this.link = new LinkResource_1.LinkResource(config);
        this.occurrence = new OccurrenceResource_1.OccurrenceResource(config);
        this.receipt = new ReceiptResource_1.ReceiptResource(config);
        this.schedule = new ScheduleResource_1.ScheduleResource(config);
        this.search = new SearchResource_1.SearchResource(config);
        this.token = new TokenResource_1.TokenResource(config);
        this.source = new SourceResource_1.SourceResource(config);
        this.transfer = new TransferResource_1.TransferResource(config);
        this.transaction = new TransactionResource_1.TransactionResource(config);
        this.fundAccount = new FundAccountResource_1.FundAccountResource(config);
        this.fundSource = new FundSourceResource_1.FundSourceResource(config);
        this.fundRequest = new FundRequestResource_1.FundRequestResource(config);
    }
    return OmiseClient;
}());
exports.OmiseClient = OmiseClient;
